SystemOrganization addCategory: #SWA014!

Object subclass: #SWA014Game
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

SWA014Game class
	instanceVariableNames: 'swaworld'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

SWA014Game class
	instanceVariableNames: 'swaworld'!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'M.V. 11/13/2016 16:08'!
gameOver
	SWA014Game swaworld destroyAllEnemies.! !

!SWA014Game class methodsFor: 'accsessors' stamp: 'M.V. 11/4/2016 15:05'!
swaworld
	^swaworld.! !

!SWA014Game class methodsFor: 'accsessors' stamp: 'M.V. 11/4/2016 15:06'!
swaworld: x
	swaworld := x.! !

Object subclass: #SWA014World
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

SWA014World class
	instanceVariableNames: 'listOfEnemies player'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

SWA014World class
	instanceVariableNames: 'listOfEnemies player'!

!SWA014World class methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World class methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies: anObject
	listOfEnemies := anObject! !

!SWA014World class methodsFor: 'accessing' stamp: 'M.V. 11/11/2016 16:12'!
player
	^player.! !

!SWA014World class methodsFor: 'accessing' stamp: 'M.V. 11/11/2016 16:12'!
player: x
	player := x.! !

!SWA014World methodsFor: 'deletingObjects' stamp: 'M.V. 11/13/2016 16:26'!
destroyAllEnemies
	self flag: 'TODO: delete this method; this method only helps us controlling all objects, we do not need anymore for tests'.
	
	SWA014World  listOfEnemies do: 
	[:x| x delete].

	SWA014World player delete.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 14:26'!
height
	^World bounds corner y.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 13:07'!
size
	^size! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/4/2016 12:47'!
size: anObject
	size := anObject! !

!SWA014World methodsFor: 'spawning' stamp: 'Tc 11/15/2016 11:50'!
spawnEnemy
"spawns SWA014Enemys up to the specified number"
|enemy random r1 r2 r3 MAXSIZE NUMBER_OF_ENEMIES|
MAXSIZE := 75.
NUMBER_OF_ENEMIES := 10.

self flag: 'TODO: better: let this happen at the initialization of the world object'.
SWA014World listOfEnemies: Set new.

1 to: NUMBER_OF_ENEMIES  do:
[:x|	
	enemy := SWA014Enemy new openInWorld.
	random := Random new.
	r1 := random nextInt: self width.
	r2 := random nextInt: self height.
	r3 := random nextInt: MAXSIZE.
	enemy position: (r1@r2).
	enemy size: r3.
	enemy speed: 10.
	enemy direction: (0@0).
	SWA014World  listOfEnemies add: enemy.   
]! !

!SWA014World methodsFor: 'spawning' stamp: 'M.V. 11/12/2016 13:28'!
spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new openInWorld.
	newPlayer color: Color red.
	newPlayer size: 50.
	newPlayer speed: 10.
	SWA014World player: newPlayer.! !

!SWA014World methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/11/2016 12:01'!
width
	^ World bounds corner x.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'size speed id direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'Tc 11/16/2016 14:46'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement
	|nearestEnemyobject directionVector deltaX deltaY distance|
	
	nearestEnemyobject := self nearestEnemy.
	deltaX := (nearestEnemyobject position x - self position x).
	deltaY := (nearestEnemyobject position y - self position y).
	
	distance := ((deltaX raisedTo: 2) + (deltaY raisedTo: 2)) sqrt. "Pythagoras' theorem"
	distance == 0 ifTrue: [distance := 1.]. "prevent us from dividing by zero"
	
	directionVector := ((deltaX/distance)@(deltaY/distance)).
	nearestEnemyobject  size < self size
	ifTrue: [self direction: directionVector.] ifFalse: [self direction: ((0 @ 0) - directionVector).].
	! !

!SWA014Enemy methodsFor: 'movement' stamp: 'M.V. 11/11/2016 16:02'!
moveAutomatically
	self position: self position + (self direction).! !

!SWA014Enemy methodsFor: 'vision' stamp: 'Tc 11/16/2016 14:56'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance BIGNUMBER|
	
	BIGNUMBER := SmallInteger maxVal.
	smallestDistance := BIGNUMBER.
	nearestEnemyobject := self.
	allEnemies := Set new.
	
	allEnemies := SWA014World listOfEnemies collect: [:enemy| enemy].
	self flag: 'TODO: doofe Art zu kopieren. Geht bestimmt einfacher'.
	
	allEnemies add: SWA014World player.
	
	allEnemies do: 
	[:enemy| 
	currentDistance := self distanceTo: enemy.
	((currentDistance  < smallestDistance) and: (currentDistance ~~ 0))
	ifTrue: [smallestDistance := currentDistance.
			nearestEnemyobject := enemy.]
	].

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'M.V. 11/13/2016 15:33'!
step
	self calculateMovement.
	self moveAutomatically.
	self checkForCollisions.
	self refreshSize.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'Tc 11/16/2016 14:53'!
checkForCollisions
	|radius listOfLivingThings|
	
	radius := self size/2.
	listOfLivingThings := Set new.
	self flag: 'TODO: doofe Art zu kopieren. Geht bestimmt einfacher'.
	listOfLivingThings := SWA014World listOfEnemies collect: [:enemy| enemy].
	
	listOfLivingThings add: SWA014World player.
	
	listOfLivingThings do:
	[	
		:enemy|
		(enemy ~~ self) ifTrue: 
		[
			(enemy size < self size) ifTrue: 
			[
				((self distanceTo: enemy) < radius) ifTrue: 
				[
					self eat: enemy.
				]
			]
		]
	]! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'Tc 11/16/2016 14:52'!
distanceTo: enemy
	^(((enemy center x - self center x) raisedTo: 2)+
	((enemy center y - self center y) raisedTo: 2)) sqrt. "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'Tc 11/16/2016 14:54'!
eat: prey
	|MAX_ALLOWED_SIZE|
	self flag: 'TODO: zur Sicherheit setzte ich eine maximalgröße für blobs fest. Sollte eigentlich nicht nötig sein...'.
	MAX_ALLOWED_SIZE := 1500.
	
	self size < MAX_ALLOWED_SIZE ifTrue: 
	[
		self size: self size + prey size.
	].

	SWA014World listOfEnemies: 
		(SWA014World listOfEnemies select: [:enemy| enemy ~~ prey]).
	(prey ~~ SWA014World player) 
	ifTrue: 
	[
		prey delete.
	]
	ifFalse: 
	[
		SWA014Game gameOver.
	].! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/12/2016 13:26'!
refreshSize
	self extent: (self size)@(self size).
	
	! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/4/2016 12:34'!
size 
	^size.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/4/2016 12:34'!
size: x
	size := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed: x
	speed := x.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/11/2016 16:01'!
stepTime
	^self speed.! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'M.V. 11/13/2016 15:33'!
step
	self checkForCollisions.
	self refreshSize.! !
